# Jasmine 2.6.0 Release Notes

## Summary

This release contains a number of fixes and pull requests.

## Pull Requests & Issues

Updating introduction url to last version
  - Merges [#1316](https://github.com/jasmine/jasmine/issues/1316) from @rachelcarmena

* Throw a recognizable Error message when `fail` outside of a spec.
  - Fixes [#1017](https://github.com/jasmine/jasmine/issues/1017)

* Allow the matcher provide a custom error message
  - Merges [#1298](https://github.com/jasmine/jasmine/issues/1298) from @deckar01
  - Fixes [#1123](https://github.com/jasmine/jasmine/issues/1123)

* Fix the order in which afterAll hooks are run to match afterEach
  - Merges [#1312](https://github.com/jasmine/jasmine/issues/1312) from @gdborton
  - Fixes [#1311](https://github.com/jasmine/jasmine/issues/1311)

* Add matchers for positive and negative infinity
  - Merges [#1300](https://github.com/jasmine/jasmine/issues/1300) from @toubou91
  - Fixes [#1294](https://github.com/jasmine/jasmine/issues/1294)

* Add a first pass at JSDocs for the intended public API
  - Fixes [#596](https://github.com/jasmine/jasmine/issues/596)

* Pretty print objects passed to fail method
  - Merges [#1283](https://github.com/jasmine/jasmine/issues/1283) from @mmmichl
  - Fixes [#1090](https://github.com/jasmine/jasmine/issues/1090)

* Properly check for Error constructor from a different frame
  - Merges [#1275](https://github.com/jasmine/jasmine/issues/1275) from @anseki
  - Fixes [#1252](https://github.com/jasmine/jasmine/issues/1252)

* Add toHaveBeenCalledBefore matcher
  - Merges [#1242](https://github.com/jasmine/jasmine/issues/1242) from @DamienCassou

* Collect unhandled exceptions and pass them to the current runnable
  - Fixes [#529](https://github.com/jasmine/jasmine/issues/529)
  - Fixes [#937](https://github.com/jasmine/jasmine/issues/937)

* Nicer error messages for `spyOn` when `null` is provided
  - Fixes [#1258](https://github.com/jasmine/jasmine/issues/1258)

* Require arguments to beforeEach, it, etc, to be actual functions
  - Merges [#1222](https://github.com/jasmine/jasmine/issues/1222) from @voithos
  - Fixes [#1004](https://github.com/jasmine/jasmine/issues/1004)

* Update MIT.LICENSE for new year
    - Merges [#1249](https://github.com/jasmine/jasmine/issues/1249) from @Scottkao85

* Update README.md for new year
  - Merges [#1248](https://github.com/jasmine/jasmine/issues/1248) from @Nebojsaa

* Remove unused `message` param from Suite#pend
  - See [#1132](https://github.com/jasmine/jasmine/issues/1132)

* Fix bug where before/afterAll were being executed in disabled suites.
  - Merges [#1225](https://github.com/jasmine/jasmine/issues/1225) from @voithos
  - Fixes [#1175](https://github.com/jasmine/jasmine/issues/1175)

* Make toEqual matcher report the difference between objects
  - Merges [#1163](https://github.com/jasmine/jasmine/issues/1163) from @benchristel
  - Fixes [#675](https://github.com/jasmine/jasmine/issues/675)
  - Merges [#1236](https://github.com/jasmine/jasmine/issues/1236) from @benchristel


* Implement spies for get/set functions on accessor properties
  - Merges [#1203](https://github.com/jasmine/jasmine/issues/1203) from @celluj34
  - Merges [#1008](https://github.com/jasmine/jasmine/issues/1008) from @smacker
  - Fixes [#943](https://github.com/jasmine/jasmine/issues/943)

* When the HtmlReporter has a 'spec' query param, the spec list only shows matching specs/suites
  - Merges [#1046](https://github.com/jasmine/jasmine/issues/1046) from @d-reinhold
  - Fixes [#510](https://github.com/jasmine/jasmine/issues/510)

* createSpyObj may use object for method/response shorthand
  - Merges [#1101](https://github.com/jasmine/jasmine/issues/1101) from @mbildner

* Separate clear stack and run it after each spec
  - Fixes [#985](https://github.com/jasmine/jasmine/issues/985)
  - Fixes [#945](https://github.com/jasmine/jasmine/issues/945)
  - Fixes [#366](https://github.com/jasmine/jasmine/issues/366)

* Now spies preserve original function arity
  - Merges [#1055](https://github.com/jasmine/jasmine/issues/1055) from @kapke
  - Fixes [#991](https://github.com/jasmine/jasmine/issues/991)

* Added support for ES6 sets to toContain and toEqual.
  - Merges [#1067](https://github.com/jasmine/jasmine/issues/1067) from @alur

* Correctly pretty print objects from other contexts (e.g. iframes) and which do not override toString
  - Merges [#1091](https://github.com/jasmine/jasmine/issues/1091) from @thatfulvioguy
  - Fixes [#1087](https://github.com/jasmine/jasmine/issues/1087)

* Pass custom testers to asymmetric testers
  - Merges [#1139](https://github.com/jasmine/jasmine/issues/1139) from @joeyparrish
  - Fixes [#1138](https://github.com/jasmine/jasmine/issues/1138)

* Fix bad url in README
  - Merges [#1215](https://github.com/jasmine/jasmine/issues/1215) from @mattc41190

------

_Release Notes generated with _[Anchorman](http://github.com/infews/anchorman)_
